QUIT ;
ods html close ;
ods html ;
TITLE ;


/***
BIOSTATISTICS IN A NUTSHELL

Pascal Tyrrell,  PhD		Associate Professor
Department of Medical Imaging , Faculty of Medicine
Institute of Medical Science, Faculty of Medicine
Department of Statistical Sciences , Faculty of Arts and Science

Paul Corey,  PhD		Professor Emeritus
Biostatistics Program, Dalla Lana Faculty of Public Health
Institute of Medical Science, Faculty of Medicine
Department of Statistical Sciences, Faculty of Arts and Science




/*** PART 1 ***/

TITLE1  "  FREQ PROCEDURE IS FIRST PROGRAM RUN  " ;

DATA  FINAL ; INPUT CURE $  N  @@ ;    
DATALINES ; 
NO   2  YES  8 
RUN ;

PROC  FREQ  DATA = FINAL ; WEIGHT  N ;   
TABLES  CURE  /  BINOMIAL  ;  EXACT   BINOMIAL  ;  RUN ;


DATA UNPAIRED ;  
INPUT COLOUR $ RTIME @@ ;  
DATALINES ;
GREEN 232.6    RED 232.0    
GREEN 257.5    RED 250.5    
GREEN 253.1    RED 237.1    
GREEN 205.4    RED 201.5    
GREEN 226.0    RED 211.1    
RUN ; 

DATA PAIRED  ;   
INPUT   RTIMEG   RTIMER  @@ ;     
DIFFRT = RTIMEG  -  RTIMER  ;   
DATALINES ;         
232.6    232.0        
257.5    250.5        
253.1    237.1        
205.4    201.5        
226.0    211.1        
RUN ; 
PROC SORT DATA = UNPAIRED ; BY COLOUR ; RUN ;
PROC MEANS   DATA = UNPAIRED   N   MEAN   VAR STD   STDERR MAXDEC = 3  ;  
BY COLOUR ;
VAR   RTIME ; 
RUN ;

PROC    TTEST    DATA = UNPAIRED ; 
CLASS   COLOUR ;   VAR   RTIME ;   RUN ;

PROC MEANS   DATA = PAIRED   N   MEAN   VAR STD   STDERR T PRT MAXDEC = 3  ;  
VAR   RTIMEG   RTIMER DIFFRT ; 
RUN ;

TITLE1   "     COMPARING TWO SAMPLE MEANS        "    ;
TITLE2   "  ASSUMING A MATCHED PAIRED DESIGN   "   ;
PROC  TTEST  DATA = PAIRED;  PAIRED  RTIMEG * RTIMER ;  RUN;   

DATA  T1 ; INPUT  GROUP  DBP @@ ;  
DATALINES ; 
1 3   1 4   1 5   1 6   1 7  
0 1   0 3   0 5   0 7   0 9   0 13  0 15  0 17  0 19  0 21
RUN ;  

PROC    MEANS  N  MEAN  STD  VAR  MAXDEC = 2  ; 
CLASS   GROUP  ;   VAR  DBP ;   RUN ;  

PROC   TTEST   DATA = T1   CI=NONE  ; 
CLASS  GROUP ;    VAR   DBP ;   RUN  ; 


DATA  T2 ;   INPUT  GRP  DBP  @@ ;   DATALINES ; 
1  1   1  2   1   3    1   4   1   5   1 6  1 7  1 8  1 9  1 10
0  1   0  7   0  13   0 19   0 25 
RUN ; 

PROC MEANS  N  MEAN  STD  VAR  T  PRT  MAXDEC = 2 ; 
CLASS  GRP  ;   VAR  DBP ;   RUN  ;  

PROC TTEST DATA  =  T2   CI = NONE ; 
CLASS  GRP ;   VAR  DBP ;   RUN ; 




/*** PART 2   ***/

TITLE1  "  COMPARING SAME MEANS USING GLM PROCEDURE  "  ; 
DATA  STUDY ; INPUT  COLOUR $  NAME $   ID   RTIME ;  
DATALINES ;      
GREEN      ABEL     1       232.6
RED        ABEL     1       232.0
GREEN      ADAM     2       257.5
RED        ADAM     2       250.5
GREEN      AMOS     3       253.1
RED        AMOS     3       237.1
GREEN      ANDY     4       205.4
RED        ANDY     4       201.5
GREEN      BART     5       226.0
RED        BART     5       211.1
RUN;   ** NOTE: MOST DATASETS HAVE A LINE OF DATA FOR EACH SUBJECT;


TITLE1  "  ASSUMING A COMPLETELY RANDOMIZED DESIGN  "   ; 
PROC  GLM  DATA = STUDY ;  CLASS COLOUR ;    
MODEL  RTIME = COLOUR ;  
LSMEANS  COLOUR / TDIFF  PDIFF  STDERR  CL ;  RUN  ;  
TITLE1  "  ASSUMING A RANDOMIZED BLOCK DESIGN  "   ; 
PROC  GLM  DATA = STUDY ;  CLASS COLOUR  ID ; 
MODEL  RTIME  =  COLOUR ID ;  **Note  ID in MODEL statement ;
LSMEANS  COLOUR / TDIFF   PDIFF   STDERR   CL  ;  RUN  ;  


TITLE1 " COMPARING TWO DRUGS ";
PROC GLM DATA=STUDY; CLASS DRUG SEX ; 
MODEL RTIME = 
DRUG  SEX  DRUG * SEX AGE WEIGHT / SS3;       

LSMEANS DRUG/TDIFF PDIFF STDERR CL; 
LSMEANS SEX /TDIFF PDIFF STDERR CL; RUN ;


DATA REACTION ; INPUT  MEAN10 EXERCISE $ ID COLOUR $ GROUP ;  
DATALINES ;      
0.28777 YES 7 RED 2 
0.27179 NO 7 RED 4 
0.37966 NO 7 GREEN 3 
0.27569 YES 7 GREEN 1 
0.24455 YES 2 GREEN 1 
0.24683 NO 2 RED 4 
0.26403 YES 2 RED 2 
0.24303 NO 2 GREEN 3 
0.29935 YES 8 RED 2 
0.29268 YES 8 GREEN 1 
0.29586 NO 8 RED 4 
0.30994 NO 8 GREEN 3 
0.32525 YES 16 RED 2 
0.43577 NO 16 GREEN 3 
0.40072 NO 16 RED 4 
0.34072 YES 16 GREEN 1 
0.31957 NO 18 GREEN 3 
0.33224 YES 18 GREEN 1 
0.29628 YES 18 RED 2 
0.28355 NO 18 RED 4 
0.34297 YES 1 GREEN 1 
0.38213 NO 1 GREEN 3 
0.29460 YES 1 RED 2 
0.32074 NO 1 RED 4 
0.31300 NO 17 RED 4 
0.37588 YES 17 RED 2 
0.40757 NO 17 GREEN 3 
0.39778 YES 17 GREEN 1 
0.28789 NO 24 RED 4 
0.25001 YES 24 GREEN 1 
0.26809 NO 24 GREEN 3 
0.24230 YES 24 RED 2 
0.24596 YES 9 GREEN 1 
0.23029 NO 9 RED 4 
0.26610 NO 9 GREEN 3 
0.23112 YES 9 RED 2 
0.22730 NO 13 RED 4 
0.24637 YES 13 GREEN 1 
0.24764 YES 13 RED 2 
0.25930 NO 13 GREEN 3 
0.29499 YES 10 GREEN 1 
0.38668 NO 10 GREEN 3 
0.36707 NO 10 RED 4 
0.29197 YES 10 RED 2 
0.30416 YES 20 RED 2 
0.30555 NO 20 RED 4 
0.35767 YES 20 GREEN 1 
0.41489 NO 20 GREEN 3 
0.25466 NO 14 RED 4 
0.25265 NO 14 GREEN 3 
0.26132 YES 14 GREEN 1 
0.25173 YES 14 RED 2 
0.30490 NO 21 GREEN 3 
0.27330 YES 21 RED 2 
0.28878 NO 21 RED 4 
0.27457 YES 21 GREEN 1 
0.33627 NO 3 GREEN 3 
0.25822 YES 3 GREEN 1 
0.27903 NO 3 RED 4 
0.24274 YES 3 RED 2 
0.28851 NO 4 GREEN 3 
0.28853 YES 4 RED 2 
0.29192 YES 4 GREEN 1 
0.28706 NO 4 RED 4 
0.46655 YES 23 GREEN 1 
0.47720 YES 23 RED 2 
0.40934 NO 23 RED 4 
0.45355 NO 23 GREEN 3 
0.24784 NO 19 RED 4 
0.29878 YES 19 RED 2 
0.26728 YES 19 GREEN 1 
0.23754 NO 19 GREEN 3 
0.29262 YES 5 RED 2 
0.47031 NO 5 GREEN 3 
0.38219 YES 5 GREEN 1 
0.33895 NO 5 RED 4 
0.26020 YES 15 GREEN 1 
0.27863 YES 15 RED 2 
0.26971 NO 15 GREEN 3 
0.26824 NO 15 RED 4 
0.25714 NO 6 RED 4 
0.27317 NO 6 GREEN 3 
0.25564 YES 6 RED 2 
0.23553 YES 6 GREEN 1 
0.26463 YES 12 RED 2 
0.30168 YES 12 GREEN 1 
0.32871 NO 12 GREEN 3 
0.32457 NO 12 RED 4 
0.31941 NO 22 GREEN 3 
0.29038 NO 22 RED 4 
0.32349 YES 22 RED 2 
0.31428 YES 22 GREEN 1 
0.44340 NO 11 GREEN 3 
0.43223 NO 11 RED 4 
0.39374 YES 11 RED 2 
0.43905 YES 11 GREEN 1 
RUN ;


PROC GLM DATA = REACTION ; 
CLASS GROUP ; 
MODEL MEAN10 = GROUP / SS3 ; 
LSMEANS GROUP/ ADJUST=T TDIFF PDIFF CL ; 
RUN ;


PROC GLM DATA=REACTION  ; 
CLASS GROUP ID ;
MODEL MEAN10 = GROUP ID / SS3 ; 
LSMEANS GROUP/ADJUST=T     TDIFF PDIFF CL;  
LSMEANS GROUP/ADJUST=TUKEY TDIFF PDIFF CL;  
RUN ;     


PROC GLM DATA=REACTION ;
CLASS COLOUR EXERCISE ; 
MODEL MEAN10 = COLOUR EXERCISE COLOUR*EXERCISE /SS3; 
LSMEANS COLOUR         /ADJUST=T TDIFF PDIFF CL;  
LSMEANS EXERCISE       /ADJUST=T TDIFF PDIFF CL;  
LSMEANS COLOUR*EXERCISE/ADJUST=T TDIFF PDIFF CL; 
RUN ;



PROC GLM DATA=REACTION  ;
CLASS COLOUR EXERCISE ID ; 
MODEL MEAN10 = COLOUR EXERCISE COLOUR*EXERCISE ID /SS3; 
LSMEANS COLOUR         /ADJUST=T TDIFF PDIFF CL;  
LSMEANS EXERCISE       /ADJUST=T TDIFF PDIFF CL;  
LSMEANS COLOUR*EXERCISE/ADJUST=tukey TDIFF PDIFF CL; 
RUN ;


PROC GLM  DATA = DRUGS ; 
CLASS DRUG SEX ;   
MODEL  FVC  =  DRUG SEX AGE HEIGHT WEIGHT ;  
LSMEANS DRUG ; 
LSMEANS SEX ; 
RUN ;



/*** PART 3   ***/


DATA UNPAIRED ; INPUT ID $  EXER  HGT  FVC  @@ ; 
EXERCISE = "YES" ; 
IF EXER=0 THEN EXERCISE=" NO"; DATALINES ;            
 1 0 120 1.00   2 0 130 1.40   3 0 135 2.04  
 4 0 145 2.00   5 0 140 2.70   6 0 150 2.00  
 7 0 155 3.25   8 0 160 2.50   9 0 170 3.20  
10 0 190 4.50  
11 1 140 1.92  12 1 150 3.30  13 1 154 3.00  
14 1 143 2.82  15 1 164 3.55  16 1 170 4.30  
17 1 174 3.68  18 1 172 2.78  19 1 174 4.20  
20 1 183 4.28
RUN ;         

DATA PAIRED ; INPUT ID $  EXER  HGT  FVC @@ ; 
EXERCISE = "YES" ; 
IF EXER=0 THEN EXERCISE =" NO"; DATALINES ;            
 1 0 120 1.00   2 0 130 1.40   3 0 135 2.04  
 4 0 145 2.00   5 0 140 2.70   6 0 150 2.00  
 7 0 155 3.25   8 0 160 2.50   9 0 170 3.20  
10 0 190 4.50  
 1 1 140 1.92   2 1 150 3.30   3 1 154 3.00  
 4 1 143 2.82   5 1 164 3.55   6 1 170 4.30  
 7 1 174 3.68   8 1 172 2.78   9 1 174 4.20  
10 1 183 4.28
RUN ;  

DATA  PAIRS ; INPUT FVC1 FVC2 @@ ;   
DFVC = FVC1 - FVC2 ; 
DATALINES ; 
1.00  1.92   1.40  3.30   2.04  3.00  2.00  2.82 
2.70  3.55   2.00  4.30   3.25  3.68  2.50  2.78 
3.20  4.20   4.50  4.28
RUN ;  

PROC MEANS DATA = PAIRS N MEAN VAR STDDEV ;
VAR FVC1 FVC2 DFVC ;
RUN ;


PROC TTEST  DATA = PAIRS  ; PAIRED FVC1 * FVC2 ; RUN ;
PROC CORR   DATA = PAIRS  ; VAR    FVC1   FVC2 ; RUN ; 
PROC GPLOT  DATA = PAIRS  ; PLOT   FVC1 * FVC2 ; RUN ; 
/**********************************************************************
* Var(X2 - X1) = Var(X2)  + Var(X1) - 2 x Std(X2) x  Std(X1) x  R     *
*    0.537     =  1.028   +  0.600  - 2 x 1.014   x  0.775   x  0.694 * 
**********************************************************************/

PROC GLM DATA = PAIRS ;
MODEL  FVC2 = FVC1 ; 
RUN ;   

PROC TTEST DATA = PAIRS ;     **<< Done ;
VAR DFVC ;
RUN ; 

PROC GLM DATA = PAIRED ;
CLASS EXERCISE ID ; 
MODEL FVC =  EXERCISE  ID / SS3 ;
LSMEANS EXERCISE / TDIFF PDIFF STDERR CL ;   
RUN ;     


PROC TTEST  DATA = UNPAIRED  ; 
CLASS EXERCISE ; 
VAR FVC ; 
RUN ;
 
PROC GLM DATA = unpaired ; 
class exer ;
MODEL FVC = EXER  HGT ;  RUN ; 


PROC TTEST  DATA = UNPAIRED  CL = NONE ;  **<< Done;
CLASS EXERCISE ;
VAR FVC  ;   
RUN ; 

PROC  GLM  DATA = UNPAIRED;   
CLASS EXERCISE ; 
MODEL FVC  =  EXERCISE  /  SS3 ;
LSMEANS EXERCISE / TDIFF PDIFF STDERR CL ; 
RUN ;     

PROC SORT DATA = STUDY ; BY EXER ; RUN ;

PROC TTEST DATA = UNPAIRED ;
CLASS EXERCISE ;
VAR HGT ;
RUN ;

PROC GLM  DATA = UNPAIRED ; 
BY EXER ; 
MODEL FVC = HGT ; 
RUN ;           

PROC GLM DATA = UNPAIRED ; 
CLASS EXERCISE ;
MODEL FVC = EXERCISE  HGT  EXERCISE*HGT /SS3 solution ;
RUN ; 

PROC GLM DATA = UNPAIRED ; 
CLASS EXERCISE ;
MODEL FVC =  exercise  EXERCISE*HGT / noint SS3 solution ;
RUN ; 

PROC GLM DATA = UNPAIRED ; 
CLASS EXERCISE ;
MODEL FVC = EXERCISE  HGT / SOLUTION SS3 ;
RUN ; 

PROC GLM DATA = UNPAIRED ; 
by EXERCISE ;
MODEL FVC =  HGT / SOLUTION SS3 ;
RUN ; 


DATA UNPAIRED_I ; INPUT ID $  EXER  HGT  FVC  @@ ; 
EXERCISE = "YES" ; 
IF EXER=0 THEN EXERCISE=" NO"; DATALINES ;            
 1 0 120 1.00   2 0 130 1.40   3 0 135 2.04  
 4 0 145 2.00   5 0 140 2.70   6 0 150 2.00  
 7 0 155 3.25   8 0 160 2.50   9 0 170 3.20  
10 0 190 4.45  
11 1 140 2.12  12 1 150 3.10  13 1 154 3.10  
14 1 143 2.22  15 1 164 3.65  16 1 170 4.40  
17 1 174 4.01  18 1 172 3.98  19 1 174 4.80  
20 1 183 5.28
RUN ;         

PROC TTEST  DATA = UNPAIRED_I  CL = NONE ;  
CLASS EXERCISE ;
VAR FVC  ;   
RUN ; 


PROC GLM DATA = UNPAIRED_I ; 
Class EXERCISE ;
MODEL HGT =  EXERCISE / SOLUTION SS3 ;
RUN ; 

PROC GLM DATA = UNPAIRED_I ; 
MODEL FVC =  HGT / SOLUTION SS3 ;
RUN ; 


PROC GLM DATA = unpaired_I ; 
class exer ;
MODEL FVC =  EXER|HGT / solution SS3 ;  
lsmeans exer*HGT /TDIFF PDIFF ; RUN ; 

PROC GLM DATA = unpaired_I ; 
class exer ;
MODEL FVC =  EXER HGT*EXER / NOINT solution ;  
lsmeans exer /TDIFF PDIFF ; RUN ; 

PROC GLM DATA = unpaired_I ; 
by exercise ;
MODEL FVC =  HGT / solution SS3 ;  
RUN ; 


DATA INBRED ; INPUT INBRED @@ ;   
GROUP = "INBRED " ; DATALINES; 
139 163 160 160 147 149 149 122 
132 144 130 144 102 124 144   
RUN; 

DATA CROSSED ; INPUT CROSSED @@ ; 
GROUP = "CROSSED" ; DATALINES;  
188  96 168 176 153 172 177 163 
146 173 186 168 177 184  96 
RUN;

DATA WIDE; MERGE CROSSED INBRED; 
DROP GROUP; PAIR = _N_ ; 
DIFF = CROSSED - INBRED ; RUN;    

TITLE1 "CROSSED AND INBRED PLANTS";
PROC PRINT DATA = WIDE NOOBS; RUN;


TITLE1 "ASSUMING PLANTS WERE PAIRED"; 
PROC MEANS DATA=WIDE MEAN T PRT CLM MAXDEC=1;  
VAR CROSSED INBRED DIFF ; RUN ; 

PROC TTEST DATA=WIDE; PAIRED CROSSED*INBRED; RUN; 

TITLE1 "PEARSON CORRELATION COEFFICIENT";
PROC CORR  DATA=WIDE; VAR CROSSED INBRED; RUN;


TITLE1 "  CREATING TWO DATASETS  "; 
TITLE2 "IGNORING POSSIBLE PAIRING";  
DATA LONGCROSS; SET CROSSED; 
GROUP = "CROSSED"; HEIGHT=CROSSED; RUN; 

DATA LONGINBRED ; SET INBRED ; 
GROUP = "INBRED "; HEIGHT=INBRED; RUN;

DATA LONG; SET LONGCROSS LONGINBRED; RUN; 

PROC GLM DATA=LONG ; CLASS GROUP ;  
MODEL HEIGHT = GROUP / SS3 ; RUN;

PROC TTEST DATA = LONG ;
CLASS GROUP ;
VAR HEIGHT ;
RUN ;




/*** PART 4   ***/


DATA  T ; 
INPUT  GROUP $  SUCCESS $  N  @@  ;  
DATALINES ;
DRUG       NO  3  DRUG     YES    7
PLACEBO    NO  8  PLACEBO  YES    2
RUN ;
PROC  PRINT DATA = T; RUN ; 

PROC FREQ DATA = T ;
TABLES GROUP*SUCCESS/ NOPERCENT NOCOL  NOROW 
CHISQ  FISHER   EXPECTED ;
WEIGHT N ;
RUN ;

DATA  PERSONS ;  INPUT GROUP $ SUCCESS $ @@;
DATALINES ;
DRUG NO    DRUG NO    DRUG NO   DRUG YES  
DRUG YES   DRUG YES   DRUG YES  DRUG YES  
DRUG YES   DRUG YES
PLACEBO NO    PLACEBO NO    PLACEBO YES    PLACEBO  YES
PLACEBO YES   PLACEBO YES   PLACEBO YES    PLACEBO  YES
PLACEBO YES   PLACEBO YES
RUN   ; 

PROC FREQ DATA = T ;
TABLES GROUP*SUCCESS/ NOPERCENT NOCOL  NOROW 
CHISQ  FISHER   EXPECTED ;
RUN ;


DATA TTT ; 
LIKELIHOOD0  =  ((11/20)**11)  *  ((9/20)**9)   ;
LIKELIHOOD1  =  (( 3/10)** 3)  *  ((7/10)**7)   ; 
LIKELIHOOD2  =  (( 8/10)** 8)  *  ((2/10)**2)   ;
LR  =   LIKELIHOOD0 / (LIKELIHOOD1  * LIKELIHOOD2 ) ;  
MINUS2LOGL = -2 * LOG(LR); 
RUN ; PROC  PRINT ; RUN ; 

TITLE1 "   LIKELIHOOD RATIO TEST  "; 
DATA TT ;  
P1  = (0.30)**3 * (0.70)**7 ;
P2  = (0.80)**8 * (0.20)**2 ;
PH0 = (0.55)**11 * (0.45)**9 ; 
LR  = PH0 / (P1 * P2); MINUS2LOGLR = - 2 * LOG(LR) ;  
Z   = SQRT(MINUS2LOGLR) ; 
PVALUE1 = SDF('CHISQUARE' , MINUS2LOGLR, 1) ; 
PVALUE2 = 2 * SDF('NORMAL', Z, 0, 1); RUN ; 
PROC  PRINT ;  RUN  ; 


DATA  T  ;   
INPUT  DRUG $  SUCCESS $   N   @@  ;   
DATALINES   ;
ASPIRIN       NO  3        ASPIRIN  YES    7
PLACEBO       NO  8        PLACEBO  YES    2
RUN ;
PROC   LOGISTIC   DATA = T ;   
CLASS  DRUG (ref="ASPIRIN")/ param = ref ;   WEIGHT  N ;  
MODEL  SUCCESS  =  DRUG  ; RUN ; 

PROC  LOGISTIC   DATA = T ;   
CLASS DRUG ;   WEIGHT  N ;  
MODEL  SUCCESS  =  DRUG SEX AGE ; RUN ; 
